package de.uni_kassel.usf.LandReclamationJess;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Enumeration;
import java.util.Hashtable;
import java.lang.Math;

import uchicago.src.sim.util.Random;

/**
 * Adapted from ruth's climate class in the cloud model
 * 
 */
public class Climate {
    public static final int totalYears = 157;

    public static int climate_history[] = new int[totalYears];

    public Weather currentWeather = new Weather();

    private double propWet = 0.3, propDry = 0.3;

    private static int[] weather_sequence
        = { 
        Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.WET, Weather.WET, Weather.WET
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
        , Weather.DRY, Weather.DRY, Weather.DRY
        , Weather.NORMAL, Weather.NORMAL, Weather.NORMAL
    };



    public Climate(double propWet, double propDry) {
        for (int i=0;i<0;i++)
            weather_sequence[i] = Weather.DRY;
        for (int i=0;i<weather_sequence.length;i++){
            double rnd = Random.uniform.nextDouble();
            if (rnd<propWet)
                weather_sequence[i] = Weather.WET;
            else if (rnd<propWet+propDry)
                weather_sequence[i] = Weather.DRY;
            else
                weather_sequence[i] = Weather.NORMAL;
        }
    }

    /**
     * @param year
     *            current year
     */
    public void step(int year) {
        generateWeather(year);
    }

    /**
     * @param year
     *            current year
     */
    public void generateWeather(int year) {
//        double rand = Random.uniform.nextDoubleFromTo(0, 1);
//        if (rand <= propWet)
//            currentWeather.setRaintype(Weather.WET);
//        else if (rand <= propWet + propDry)
//            currentWeather.setRaintype(Weather.DRY);
//        else
//            currentWeather.setRaintype(Weather.NORMAL);
        
        currentWeather.setRaintype(weather_sequence[year-1]);
        climate_history[year] = currentWeather.getRaintype();
    }

    /**
     * Need to provide markers for drought and flood events, so that they
     * provide an anchor for memory and bias in future response.
     * 
     * @param year
     *            current year
     * @return array object containing climate history
     */
    public int getHistory(int year) {
        return climate_history[year];
    }

    /**
     * Influence of past experience on perception and expectation of foreacst
     * information e.g. if more dry years than wet in memory, expect drier
     * forecast. Eg. normal if forecast is for wet.
     * 
     * @param current_year
     *            current year
     * @param years
     *            number of years in memory
     * @return bias whether towards expectation of wetter or drier weather.
     */
    // public boolean calcClimateMemory(int current_year, int years){
    // int wet=0, dry=0;
    // for (int i=current_year; i > current_year - years; i--) {
    // if (getHistory(i-1) == Weather.WET) {
    // wet++;
    // }
    // else {
    // dry++;
    // }
    // }
    // if (dry > wet) {
    // expect_dry = true;
    // //if more dry years than wet in memory, expect drier forecast. Eg. normal
    // if forecast is for wet.
    //    }
    //    else {
    //      expect_dry = false;
    //    }return expect_dry;
    //  }
}
