package de.uni_kassel.usf.LandReclamationJess;

import java.util.ArrayList;
import java.util.Iterator;

import uchicago.src.sim.util.Random;

public class Line {
    private ArrayList<Point> vertexList;
    private ArrayList<Point> pointList;

    public Line(){
        vertexList = new ArrayList<Point>();
        pointList = new ArrayList<Point>();
    }
    
    public void addVertex(int x,int y){
        vertexList.add(new Point(x,y));
    }

    /**
     * @return Returns the pointList.
     */
    public ArrayList<Point> getPointList() {
        return pointList;
    }

    
    /**
     * generates a list of points between the defining vertices of the line
     */
    public void setPointList() {
        pointList.clear();
        double dx,dy,m,b;
        Iterator<Point> it = vertexList.iterator();
        Point lastVertex = it.next();
        Point presentVertex;
        while(it.hasNext()){
            presentVertex = it.next();
            dx = (double)(presentVertex.getX()-lastVertex.getX());
            if (dx==0){
                for (int y=lastVertex.getY();y<=presentVertex.getY();y++){
                    pointList.add(new Point(presentVertex.getX(),y));
                }
            } else {
                dy = (double)(presentVertex.getY()-lastVertex.getY());
                m = dy/dx;
                b = lastVertex.getY() - m*lastVertex.getX();
                for (int x=lastVertex.getX();x<=presentVertex.getX();x++){
                    pointList.add(new Point(x,(int) Math.round(m*x+b)));
                }
            }
            lastVertex = presentVertex;
        }
    }

    public Point getRandomPointNear(double minDist, double maxDist, double maxX, double maxY){
        int x,y;
        int i;
        double dx,dy,m,b,randDist;
        i = Random.uniform.nextIntFromTo(1,pointList.size()-1);
        Point linePoint1 = pointList.get(i-1);
        Point linePoint2 = pointList.get(i);
        dx = (double)(linePoint2.getX()-linePoint1.getX());
        dy = (double)(linePoint2.getY()-linePoint1.getY());
        do {
            randDist = Math.signum(Random.uniform.nextDoubleFromTo(-0.5,0.5))*(minDist+Random.uniform.nextDoubleFromTo(0,maxDist));
            if (dx==0){
                x = (int) (linePoint2.getX() + randDist);
                y = linePoint2.getY();
            } else {
                if (dy==0){
                    x = (int) linePoint2.getX();
                    y = (int) (linePoint2.getY() + randDist);
                } else {
                    m = Math.tan(Math.PI/2+Math.atan(dy/dx));
                    x = (int) (linePoint2.getX() + randDist);
                    y = (int) (linePoint2.getY() + m*randDist);
                }
            }
        } while (x<0 || x>maxX || y<0 || y>maxY);
        return (new Point(x,y));
    }
    
    
}
