package de.uni_kassel.usf.LandReclamationJess;

import java.awt.Color;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.*;

import sun.security.acl.WorldGroupImpl;
import uchicago.src.sim.gui.ColorMap;
import uchicago.src.sim.space.Neighborhooder;
import uchicago.src.sim.space.Object2DGrid;
import uchicago.src.sim.space.Object2DTorus;
import uchicago.src.sim.util.Random;


public class Space {

    private Object2DGrid resourceSpace;

    private Object2DGrid landParcelSpace;
    private ArrayList<LandParcel> LPList = new ArrayList<LandParcel>();

    private Object2DGrid LRSSpace;

    private Object2DGrid channelSpace;
    private Line channel1;
    private Line channel2;

    private Object2DGrid agentSpace;
    public static int numQuads = 4;
    public int calcQuadrant(int y){
        int quadSize = agentSpace.getSizeY()/numQuads;
        return(y/quadSize);
    }
    
    
    private Model model;
    
    private Climate climate;
    
    private static final Color[] COLOR = {/*Color.blue,*/ Color.white,Color.cyan, Color.darkGray, Color.gray
        , Color.lightGray, Color.magenta, Color.orange, Color.pink, Color.red,Color.yellow };


    public Space(){
    }
    
    public Space(int xSize, int ySize) {
        
        resourceSpace = new Object2DGrid(xSize, ySize);
        
        channelSpace = new Object2DGrid(xSize, ySize);
        
        agentSpace = new Object2DGrid(xSize, ySize);

        landParcelSpace = new Object2DGrid(xSize, ySize);

        LRSSpace = new Object2DGrid(xSize, ySize);

        agentColors = new ColorMap();
//        for(int i = 0; i<numAgentExpertises; i++){
////          agentColors.mapColor(i, (double)(i+1) / (double) numAgentExpertises, 0, 0, 1);
////          agentColors.mapColor(i, 0,0,1,(double)(i+1) / (double) numAgentExpertises);
////          agentColors.mapColor(i, 0,0,(double)(i+1) / (double) numAgentExpertises,1);
//          agentColors.mapColor(i,COLOR[i]);
//      }

        for(int i = 0; i<10; i++){
          agentColors.mapColor(i,COLOR[i]);
      }

        for (int i = 0; i < xSize; i++) {
            for (int j = 0; j < ySize; j++) {
                resourceSpace.putObjectAt(i, j, new Integer(0));
            }
        }
        
        for (int i = 0; i < xSize; i++) {
            for (int j = 0; j < ySize; j++) {
                landParcelSpace.putObjectAt(i, j, new Integer(0));
            }
        }
        
        for (int i = 0; i < xSize; i++) {
            for (int j = 0; j < ySize; j++) {
                LRSSpace.putObjectAt(i, j, new Double(0));
            }
        }
        
        for (int i = 0; i < xSize; i++) {
            for (int j = 0; j < ySize; j++) {
                channelSpace.putObjectAt(i, j, new Integer(0));
            }
        }
        

//        channel1 = new Line();
//        channel1.addVertex(10,10);
//        channel1.addVertex(20,15);
//        channel1.addVertex(30,30);
//        channel1.setPointList();
//
//        Line ch1 = new Line();
//        ch1.addVertex(30,30);
//        ch1.addVertex(35,33);
//        ch1.addVertex(37,40);
//        ch1.setPointList();
//
//        channel2 = new Line();
//        channel2.addVertex(37,40);
//        channel2.addVertex(45,55);
//        channel2.addVertex(50,60);
//        channel2.setPointList();
//   
//        for (Point p : channel1.getPointList()){
//            channelSpace.putObjectAt(p.getX(),p.getY(),new Integer(1));
//            resourceSpace.putObjectAt(p.getX(),p.getY(), new Integer(0));
//        }
//        for (Point p : ch1.getPointList()){
//            channelSpace.putObjectAt(p.getX(),p.getY(),new Integer(1));
//            resourceSpace.putObjectAt(p.getX(),p.getY(), new Integer(0));
//        }
//        for (Point p : channel2.getPointList()){
//            channelSpace.putObjectAt(p.getX(),p.getY(),new Integer(1));
//            resourceSpace.putObjectAt(p.getX(),p.getY(), new Integer(0));
//        }
        
        
    }

    public ColorMap agentColors;
    
    public void generateDependencies(){
        for (SandboxAgent a: model.agentList){
            int nearestY = agentSpace.getSizeY()+1;
            for (SandboxAgent b: model.agentList){
                if (b.getY()>a.getY() && b.getY()<nearestY){
                    nearestY=b.getY();
                }
            }
            if (nearestY<agentSpace.getSizeY()+1){
                for (SandboxAgent b: model.agentList){
                    if (b.getY()==nearestY){
                        b.getDependencyNode().makeEdgeTo(a.getDependencyNode());
                    }
                }
            }
        }        
    }
    

    public int getResourceAt(int x, int y) {
        int i;
        if (resourceSpace.getObjectAt(x, y) != null) {
            i = ((Integer) resourceSpace.getObjectAt(x, y)).intValue();
        } else {
            i = 0;
        }
        return i;
    }

    public boolean cellOccupied(int x, int y) {
        boolean retVal = false;
        if (agentSpace.getObjectAt(x, y) != null)// || getResourceAt(x,y)!=0)
            retVal = true;
        return retVal;
    }

    public boolean spaceOccupied(int x, int y, int height) {
        boolean occupied = false;
        int dx=0;
        int dy;
        do {
        	dy=0;
        	do {
//            	occupied = agentSpace.getObjectAt(x+dx,y+dy) != null;
            	occupied = ((Integer) landParcelSpace.getObjectAt(x+dx,y+dy)).intValue()!=0;
        		
        	}while(!occupied && dy++<height-1);
        }while(!occupied && dx++<height-1);

//        if (agentSpace.getObjectAt(x, y) != null)// || getResourceAt(x,y)!=0)
//            occupied = true;

        return occupied;
    }

    public void removeAgentAt(int x, int y) {
        agentSpace.putObjectAt(x, y, null);
    }

    public SandboxAgent getAgentAt(int x, int y) {
        return (SandboxAgent) agentSpace.getObjectAt(x, y);
    }
    
    public static double getDistanceBetween(SandboxAgent a,SandboxAgent b){
        return Math.sqrt(Math.pow(b.getX()-a.getX(),2)+Math.pow(b.getY()-a.getY(),2));
    }

    public boolean addAgent(SandboxAgent agent) {
        boolean success;
        int count = 0;
        int x, y;
        int minDist = 1;
        int countLimit = 10 * agentSpace.getSizeX() * agentSpace.getSizeY();
        do {
            // Choose coordinates
            x = Random.uniform.nextIntFromTo(1+minDist,agentSpace.getSizeX()-agent.getLandParcelSize()-minDist);
            y = Random.uniform.nextIntFromTo(1+minDist,agentSpace.getSizeY()-agent.getLandParcelSize()-minDist);
            success = !spaceOccupied(x-minDist, y-minDist, agent.getLandParcelSize()+2*minDist);

            if (success) {
                agentSpace.putObjectAt(x, y, agent);
                occupyLandParcel(x, y, agent);
                agent.setXY(x, y);
                agent.setSpace(this);
            }
        } while ((!success) && (++count < countLimit));
        return success;
    }
    
    private void occupyLandParcel(int x, int y, SandboxAgent agent){
//        int dx=-agent.getLandParcelSize();
        int dx=0;
        int dy;
        do {
//            dy=-agent.getLandParcelSize();
            dy=0;
        	do {
            	landParcelSpace.putObjectAt(x+dx,y+dy,new Integer(agent.getID()));
        	}while(dy++<agent.getLandParcelSize()-1);
        }while(dx++<agent.getLandParcelSize()-1);
        
        agent.setLp(new LandParcel(agent,agent.getLandParcelSize()));
        LPList.add(agent.getLp());

    }
    
    
    private void stepCrop(){
        Integer resourceAt;
        for (int i = 0; i < resourceSpace.getSizeX(); i++) {
            for (int j = 0; j < resourceSpace.getSizeY(); j++) {
                resourceAt = (Integer) resourceSpace.getObjectAt(i,j);
                if (resourceAt.intValue()>0)
//                    resourceSpace.putObjectAt(i, j, new Integer(resourceAt.intValue()+1));
                    resourceSpace.putObjectAt(i, j, new Integer(1));
            }
        }
    }
    
    private double propMaxLoss;
    
    private void stepClimate(){
        climate.step(model.getYear());
    }
    
    public void step(){
        if (model.getMonth()==1){
            stepClimate();
            propMaxLoss = 0.0;
            if (climate.currentWeather.getRaintype()==Weather.DRY)
                propMaxLoss = 0.6;
            else if (climate.currentWeather.getRaintype()==Weather.WET)
                propMaxLoss = 1.0;
        }
        stepCrop();
        for (LandParcel lp: LPList){
            lp.degradeLRS(model.getTickCount());
        }
    }
    
    public Object2DGrid getCurrentResourceSpace() {
        return resourceSpace;
    }

    public Object2DGrid getCurrentAgentSpace() {
        return agentSpace;
    }

    /**
     * @return Returns the channelSpace.
     */
    public Object2DGrid getChannelSpace() {
        return channelSpace;
    }

    /**
     * @param channelSpace The channelSpace to set.
     */
    public void setChannelSpace(Object2DGrid channelSpace) {
        this.channelSpace = channelSpace;
    }

    /**
     * @param model The model to set.
     */
    public void setModel(Model model) {
        this.model = model;
    }

	public Object2DGrid getLandParcelSpace() {
		return landParcelSpace;
	}

	public void setLandParcelSpace(Object2DGrid landParcelSpace) {
		this.landParcelSpace = landParcelSpace;
	}


    //jess
    private PropertyChangeSupport pcs = new PropertyChangeSupport(this);
    public void addPropertyChangeListener(PropertyChangeListener p){
        pcs.addPropertyChangeListener(p);
    }
    
    public void removePropertyChangeListener(PropertyChangeListener p){
        pcs.removePropertyChangeListener(p);
    }

    /**
     * @return Returns the climate.
     */
    public Climate getClimate() {
        return climate;
    }

    /**
     * @param climate The climate to set.
     */
    public void setClimate(Climate climate) {
        this.climate = climate;
    }

    /**
     * @return Returns the propMaxLoss.
     */
    public double getPropMaxLoss() {
        return propMaxLoss;
    }

    /**
     * @param propMaxLoss The propMaxLoss to set.
     */
    public void setPropMaxLoss(double propMaxLoss) {
        this.propMaxLoss = propMaxLoss;
    }

    
}
